<?php
namespace Fiscal\Repositories;

class Trabitproimpos extends \Doctrine\ORM\EntityRepository
{
    public function impostosTemporarios($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
        SELECT SUM(T.VRIMPOSIT) VRTOTAIMPO, T.CDIMPOSTOIT
          FROM TRABITPROIMPOS T, IMPOSTO I
         WHERE CDFILIMPOIT  = :P_CDFILIAL
           AND NRLANCIMPOIT = :P_NRLANCTONF
           AND T.NRORG        = :P_NRORG
           AND IDPRODNOTA <> 'C'
           AND T.CDIMPOSTOIT = I.CDIMPOSTO
           AND T.NRORG       = I.NRORG
         GROUP BY CDIMPOSTOIT
         ORDER BY CDIMPOSTOIT
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function insertImpostosTemporariosDaItemproimpos($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
        INSERT INTO TRABITPROIMPOS
                    (
                     CDFILIMPOIT,
                     NRLANCIMPOIT,
                     NRSEQIMPOIT,
                     CDIMPOSTOIT,
                     NRSEQITPRO,
                     VRALIQIMPOIT,
                     VRCONTIMPOIT,
                     VRREDBCIMPOIT,
                     VRBCALCIMPOIT,
                     VRPDEDIMPOIT,
                     VRIMPOSIT,
                     IDVALORINFO
                    )
                    (SELECT
                     CDFILIAL,
                     NRLANCTONF,
                     NRSEQITPROD,
                     CDIMPOSTO,
                     NRITPROIMPOS,
                     VRALIQITEM,
                     VRCONTITIMP,
                     VRPERREDBCIT,
                     VRBASECALCIT,
                     VRPARDEDIT,
                     VRIMPOSTOIT,
                     IDVALORINFIT

                    FROM ITEMPROIMPOS
                    WHERE CDFILIAL   = :P_CDFILIAL AND
                          NRLANCTONF = :P_NRLANCTONF AND
                          NRORG      = :P_NRORG)
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return $this->getEntityManager()->getConnection()->executeUpdate($sql, $params);
    }

    public function insTrabItProImpos($cdfilial, $nrlanctonf, $nrseqimpoit, $cdimpostoit, $nrseqitpro, $vraliqimpoit, $vrcontimpoit, $vrredbcimpoit, $vrbcalcimpoit, $vrpdedimpoit, $vrimposto, $idvalorinfo, $nrorg){
        $sql = <<<SQL
        INSERT 
		  INTO TRABITPROIMPOS
               (CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, VRALIQIMPOIT, VRCONTIMPOIT, VRREDBCIMPOIT, VRBCALCIMPOIT, VRPDEDIMPOIT, VRIMPOSIT, IDVALORINFO, NRORG)
        VALUES
               (:P_CDFILIMPOIT, :P_NRLANCIMPOIT, :P_NRSEQIMPOIT, :P_CDIMPOSTOIT, :P_NRSEQITPRO,  :P_VRALIQIMPOIT, 0, 0, 0, 0, :P_VRIMPOSTO, :P_IDVALORINFO, :P_NRORG)
SQL;

        $params = array(
            'P_CDFILIMPOIT'   => $cdfilial,
            'P_NRLANCIMPOIT'  => $nrlanctonf,
            'P_NRSEQIMPOIT'   => $nrseqimpoit,
            'P_CDIMPOSTOIT'   => $cdimpostoit,
            'P_NRSEQITPRO'    => $nrseqitpro,
            'P_VRALIQIMPOIT'  => $vraliqimpoit,
            'P_VRCONTIMPOIT'  => $vrcontimpoit,
            'P_VRREDBCIMPOIT' => $vrredbcimpoit,
            'P_VRBCALCIMPOIT' => $vrbcalcimpoit,
            'P_VRPDEDIMPOIT'  => $vrpdedimpoit,
            'P_VRIMPOSTO'     => $vrimposto,
            'P_IDVALORINFO'   => $idvalorinfo,
            'P_NRORG'         => $nrorg
        );

        return $this->getEntityManager()->getConnection()->executeUpdate($sql, $params);
    }

    public function save($params){
        $sql = "INSERT INTO TRABITPROIMPOS
                            (CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, VRCONTIMPOIT, VRREDBCIMPOIT,
                            VRBCALCIMPOIT, VRALIQIMPOIT, VRPDEDIMPOIT, VRIMPOSIT, CDFISCIMPOIT,
                            CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, IDERRIMPOIT, IDAVISIMPOIT,
                            NRSEQITPRO, IDVALORINFO, VR1REDBCIMPOIT, IDTRIMPSTTI, CDSTRIBITNFE, IDMODBCITEMNFE,
                            IDMODBCSTITENFE, CDTPCREDPICOITE, CDNATUBCALPCIT)
                     VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
        $connection = $this->getEntityManager()->getConnection();
        return $connection->executeUpdate($sql,$params);
    }
}